<template>
	<zj-tab-page ref="tabPage" :defaultActives="[{ key: 'list', label: $route.meta.title+'-列表', essential: true }]">
		<template slot-scope="{activeKey, data}">
			<template-page v-if="activeKey == 'list'" ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
			  :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
			  :operation="operation()" :exportList="exportList">
			</template-page>
			<div v-if="~['add', 'edit', 'detail'].indexOf(activeKey)">
				<zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
				  <zj-form-module title="" label-width="100px" :showPackUp="false"
				    :form-data="formData" :form-items="formItems">
				  </zj-form-module>
				</zj-form-container>
				<div slot="footer" class="dialog-footer">
				  <el-button size="mini" @click="data.removeTab()">取 消</el-button>
				  <el-button v-if="formDialogType !== 2" size="mini" @click="formConfirm(data.removeTab)" type="primary">确 定</el-button>
				</div>
			</div>
		</template>
	</zj-tab-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import { chargingStandardList2, getMainList, getMainDetail, saveMain, deleteMain, getTypeList, getBrandList } from "@/api/miniapp";
import { getClassifyList } from '@/api/goods'
import ImageUpload from '@/components/file-upload'
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage, ImageUpload },
  mixins: [import_mixin,operation_mixin],
  data() {
    return {
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑", "查看"],
      formDialog: false,
      formData: {
        chargingStandardTypeId: "",
        brandId: "",
        oneCategoryId: "",
        twoCategoryId: "",
        status: true,
        imageUrl: [],
      },
      businessTypeList: [], // 业务类型列表
      brandList: [], // 品牌列表
      mainList: [], // 一级分类列表
      smallList: [], // 二级分类列表
	  formType: 'add',
	  formVisible: false,
    }
  },
	watch: {
		'formData.imageUrl'(){
			this.$refs?.formRef?.validateField(["imageUrl"])
		}
	},
  computed: {
	// 事件组合
	optionsEvensGroup() {
		return [
			[
				[
					this.optionsEvensAuth("add", {
						click: () => {
							this.openForm('add')
						}
					})
				],
			]
		]
	},
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [{
        md: 6,
        isShow: true,
        name: 'el-select',
        options: this.businessTypeList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '业务类型',
          prop: 'chargingStandardTypeId',
          rules: [...required]
        }
      },
      {
        md: 6,
        isShow: true,
        name: 'el-select',
        options: this.brandList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '服务品牌',
          prop: 'brandId',
          rules: [...required]
        }
      },
      {
        md: 6,
        isShow: true,
        name: 'el-select',
        options: this.mainList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '一级分类',
          prop: 'oneCategoryId',
          rules: [...required]
        },
        events: {
          change: async val => {
            this.smallList = []
            this.formData.twoCategoryId = ""
            if (val) {
              this.smallList = this.mainList.find(item => {
                return item.value == val;
              })?.data?.children?.map(item => ({
                label: item.name,
                value: item.categoryId,
                data: item
              })) || [];
            }
          }
        }
      },
      {
        md: 6,
        isShow: true,
        name: 'el-select',
        options: this.smallList,
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
        formItemAttributes: {
          label: '二级分类',
          prop: 'twoCategoryId',
          rules: [...required]
        }
      },
      {
        md: 6,
        isShow: true,
        name: 'el-radio',
        options: [{ label: "开启", value: true }, { label: "禁用", value: false }],
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2 },
        formItemAttributes: {
          label: '状态',
          prop: 'status',
          rules: [...required]
        }
      },
      {
        md: 24,
        isShow: true,
        name: 'slot-component',
        formItemAttributes: {
          label: '图片',
          prop: 'imageUrl',
          rules: [...required]
        },
        render: (h, { props, onInput }) => {
          var { value } = props
          return (
            <ImageUpload fileList={this.formData.imageUrl} uid="imgSrc_chargingStandard_materials_drawing_images" limit={1} isEdit={this.formDialogType !== 2} />
          )
        }
      },
      ]
    }
  },
  methods: {
    // 列表请求函数
    getList: chargingStandardList2,
    // 列表导出函数
    exportList() { },
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      if (item.jname === 'imageUrl') {
        defaultData.render = (h, { row, index, column }) => {
          return (
            <div style="padding:0 6px;cursor: pointer;">
              {row.imageUrl ? row.imageUrl.split(",").map(url => <el-image src={url} preview-src-list={[url]} style="width:80px;height:auto;" />) : null}
            </div>
          )
        }
      }
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    // 表格操作列
    operation() {
		return this.operationBtn({
			detail: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					this.openForm('detail',row.id)
				}
			},
			edit: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					this.openForm('edit',row.id)
				}
			},
			del: {
				btnType: 'text',
				prompt: '确定删除吗？',
				click: ({ row, index, column }) => {
					deleteMain({ id: row.id }).then(res => {
						this.$message({
							type: 'success',
							message: `删除成功!`,
						})
						this.$refs.pageRef.refreshList()
					})
				}
			}
		})
    },
	// 取消 新增编辑
	formCancel() {
	  this.formVisible = false
	  this.$refs?.formRef?.resetFields()
	  this.$data.formData = this.$options.data().formData
	},
	// 打开 新增编辑 网点表单
	openForm(type, id) {
		this.$refs.tabPage.addTab({
			// 对应显示的模块
			activeKey: type,
			// 唯一标识
			key: type,
			// 页签名称
			label: ({ edit: "编辑", add: "新增", detail: "查看" })[type],
			// 打开时事件
			triggerEvent: () => {
				this.formCancel()
				this.$nextTick(()=>{
					this.formType = type
					this.formVisible = true
					if (type == 'add') {
						this.formDialogType = 0
						this.initData()
					} else if(type == 'edit'){
						this.formDialogType = 1
						getMainDetail({ id }).then(res => {
							Object.assign(this.formData, res.data, {
								imageUrl: res.data.imageUrl ? [{ url: res.data.imageUrl }] : [],
							})
							this.initData()
						})
					}else{
						this.formDialogType = 2
						getMainDetail({ id }).then(res => {
							Object.assign(this.formData, res.data, {
								imageUrl: res.data.imageUrl ? [{ url: res.data.imageUrl }] : [],
							})
							this.initData()
						})
					}
				})
			},
			// 关闭时事件
			closeEvent: () => {
			
			}
		})
	},
    initData() {
      Promise.all([
        getTypeList(),
        getBrandList(),
        getClassifyList({
          type: 2,
          name: '',
        })
      ]).then(([res1, res2, res3]) => {
        this.businessTypeList = res1.data.map(item => ({
          label: item.name,
          value: item.id,
          data: item
        }));
        this.brandList = res2.data.map(item => ({
          label: item.brandName,
          value: item.id,
          data: item
        }));
        this.mainList = res3.data.map(item => ({
          label: item.name,
          value: item.categoryId,
          data: item
        }));
        if (this.formData.oneCategoryId) {
          this.smallList = this.mainList.find(item => {
            return item.value == this.formData.oneCategoryId;
          })?.data?.children?.map(item => ({
            label: item.name,
            value: item.categoryId,
            data: item
          })) || [];
        }
      })
    },
    formConfirm(cancel) {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          var pam = {
            ...this.formData,
            imageUrl: this.formData.imageUrl.map(item => item.url).join(","),
          };
          saveMain({ ...pam, type: 1 }).then(res => {
            this.$message({
              type: 'success',
              message: this.formDialogTitles[this.formDialogType] + `成功!`,
            })
            cancel('list')
            this.$refs.pageRef.refreshList()
          })
        }
      })
    },
  }
}
</script>

<style lang="scss" scoped></style>
